### The dataset used in "Design-Decision Support for GPU Acceleration by Predicting Energy Gain and Programming Effort" manuscript

#### final
The final datasets (csv files) used for building the estimation models in the Manuscript

#### synthetic-dataset
Generates a simple synthetic dataset
* generate.py: Usage `python generate.py <num_of_programs> <output_directory>` generates the datapoints (synthetic programs)
* run_dataset_script.py: Usage `python run_dataset_script.py <num_of_programs> <input_directory>` runs the datapoints
* measure_energy_tegra: Specific scripts for running the synthetic programs and creating energy dataset on Nvidia Tegra TX1.
    * 	remake_dataset_for_tegra.py: Small changes to the granerated programs to run on Tegra TX1
    * 	tegra_measure_new.py: Usage `python tegra_measure_new.py <num_of_programs> <input_directory>` creates the dataset

#### real-life-dataset
Method for extracting datapoints from Rodinia and Polybench benchmark suites.
*    polybench: The Polybench benchmark suite
*    rodinia_3.1: The Rodinia benchmark suite
*    config.txt: A config file that defines the areas that will be measured (corresponding to CPU-hotspots and GPU-kernels)
*    run_dataset: The scripts to build the datapoints
    *     run_dataset.py: Usage `python run_dataset.py <app_hotspot_name> <energy|time>` The <app_hotspot_name> is retrieved from the config.txt
    *     measure_time_energy.py: Used for measuring execution time and energy consumption on Nvidia Tegra TX1